import torch
import torch.nn as nn
import torch.nn.functional as F
seed = 84
torch.manual_seed(seed)
torch.manual_seed(seed)
torch.cuda.manual_seed(seed)
torch.cuda.manual_seed_all(seed)


class Encoder_hl(nn.Module):
    def __init__(self, in_channels):
        super(Encoder_hl, self).__init__()

        self.conv = nn.Conv2d(in_channels, 64, kernel_size=3, stride=1, padding=1, bias=False)
        self.bn = nn.BatchNorm2d(64)

        self.conv1 = nn.Conv2d(64, 64, kernel_size=3, stride=1, padding=1, bias=False)
        self.bn1 = nn.BatchNorm2d(64)
        self.conv2 = nn.Conv2d(64, 64, kernel_size=3, stride=1, padding=1, bias=False)
        self.bn2 = nn.BatchNorm2d(64)
        self.shortcut = nn.Sequential()

        self.conv3 = nn.Conv2d(64, 64, kernel_size=3, stride=1, padding=1, bias=False)
        self.bn3 = nn.BatchNorm2d(64)
        self.conv4 = nn.Conv2d(64, 64, kernel_size=3, stride=1, padding=1, bias=False)
        self.bn4 = nn.BatchNorm2d(64)
        self.shortcut = nn.Sequential()

        self.fc = nn.Linear(64, 128)


    def forward(self, x):
        out = F.relu(self.bn(self.conv(x)))
        x1 = out
        out = F.relu(self.bn1(self.conv1(out)))
        feature1 = out
        out = self.bn2(self.conv2(out))
        feature2 = out
        out += self.shortcut(x1)
        ty = out
        out = F.relu(out)
        x2 = out
        out = F.relu(self.bn3(self.conv3(out)))
        feature3 = out
        out = self.bn4(self.conv4(out))
        feature4 = out
        out += self.shortcut(x2)
        out = F.relu(out)

        out = F.avg_pool2d(out, 9)  #
        out = out.view(out.size(0), -1)
        out = self.fc(out)

        return [out, feature1, feature2, feature3, feature4] # ccl_ft 返回这个
        # return out  # ccl_pt 返回这个
